Update maintenance template

PATCH https://api.ap1.datadoghq.com/api/v2/statuspages/{page_id}/maintenance_templates/{template_id}https://api.ap2.datadoghq.com/api/v2/statuspages/{page_id}/maintenance_templates/{template_id}https://api.datadoghq.eu/api/v2/statuspages/{page_id}/maintenance_templates/{template_id}https://api.ddog-gov.com/api/v2/statuspages/{page_id}/maintenance_templates/{template_id}https://api.us2.ddog-gov.com/api/v2/statuspages/{page_id}/maintenance_templates/{template_id}https://api.uk1.datadoghq.com/api/v2/statuspages/{page_id}/maintenance_templates/{template_id}https://api.datadoghq.com/api/v2/statuspages/{page_id}/maintenance_templates/{template_id}https://api.us3.datadoghq.com/api/v2/statuspages/{page_id}/maintenance_templates/{template_id}https://api.us5.datadoghq.com/api/v2/statuspages/{page_id}/maintenance_templates/{template_id}

Overview

Updates an existing maintenance template’s attributes.

OAuth apps require the status_pages_settings_write authorization scope to access this endpoint.

Arguments

Path Parameters

Name

Type

Description

page_id [required]

string

The ID of the status page.

template_id [required]

string

The ID of the degradation or maintenance template.

Query Strings

Name

Type

Description

include

string

Comma-separated list of resources to include. Supported values: created_by_user, last_modified_by_user, status_page.

Request

Body Data (required)

Expand All

Field

Type

Description

data

object

The data object for updating a maintenance template.

attributes

object

The supported attributes for updating a maintenance template.

completed_description

string

The description shown when a maintenance created from this template is completed.

component_ids

[string]

The IDs of the components affected by a maintenance created from this template.

in_progress_description

string

The description shown while a maintenance created from this template is in progress.

maintenance_title

string

The title used for a maintenance created from this template.

name

string

The name of the maintenance template.

scheduled_description

string

The description shown when a maintenance created from this template is scheduled.

id [required]

string

The ID of the maintenance template.

type [required]

enum

Maintenance templates resource type. Allowed enum values: maintenance_templates

default: maintenance_templates

{
  "data": {
    "attributes": {
      "completed_description": "string",
      "component_ids": [],
      "in_progress_description": "string",
      "maintenance_title": "string",
      "name": "string",
      "scheduled_description": "string"
    },
    "id": "",
    "type": "maintenance_templates"
  }
}

Response

OK

Response object for a single maintenance template.

Expand All

Field

Type

Description

data

object

The data object for a maintenance template.

attributes

object

The attributes of a maintenance template.

completed_description

string

The description shown when a maintenance created from this template is completed.

component_ids

[string]

The IDs of the components affected by a maintenance created from this template.

created_at

date-time

Timestamp of when the maintenance template was created.

in_progress_description

string

The description shown while a maintenance created from this template is in progress.

maintenance_title

string

The title used for a maintenance created from this template.

modified_at

date-time

Timestamp of when the maintenance template was last modified.

name

string

The name of the maintenance template.

scheduled_description

string

The description shown when a maintenance created from this template is scheduled.

id

string

The ID of the maintenance template.

relationships

object

The relationships of a maintenance template.

created_by_user

object

The Datadog user who created the maintenance template.

data [required]

object

The data object identifying the Datadog user who created the maintenance template.

id [required]

string

The ID of the Datadog user who created the maintenance template.

type [required]

enum

Users resource type. Allowed enum values: users

default: users

last_modified_by_user

object

The Datadog user who last modified the maintenance template.

data [required]

object

The data object identifying the Datadog user who last modified the maintenance template.

id [required]

string

The ID of the Datadog user who last modified the maintenance template.

type [required]

enum

Users resource type. Allowed enum values: users

default: users

status_page

object

The status page the maintenance template belongs to.

data [required]

object

The data object identifying the status page associated with a maintenance template.

id [required]

string

The ID of the status page.

type [required]

enum

Status pages resource type. Allowed enum values: status_pages

default: status_pages

type [required]

enum

Maintenance templates resource type. Allowed enum values: maintenance_templates

default: maintenance_templates

included

[ <oneOf>]

The included related resources of a maintenance template. Client must explicitly request these resources by name in the include query parameter.

<type=users>

object

The included Datadog user resource.

attributes

object

Attributes of the Datadog user.

email

string

The email of the Datadog user.

handle

string

The handle of the Datadog user.

icon

string

The icon of the Datadog user.

name

string

The name of the Datadog user.

uuid

string

The UUID of the Datadog user.

id

uuid

The ID of the Datadog user.

type [required]

enum

Users resource type. Allowed enum values: users

default: users

<type=status_pages>

object

The included status page resource.

attributes

object

The attributes of a status page.

company_logo

string

The base64-encoded image data displayed in the company logo.

components

[object]

Components displayed on the status page.

components

[object]

If the component is of type group, the components within the group.

id

uuid

The ID of the grouped component.

name

string

The name of the grouped component.

position

int64

The zero-indexed position of the grouped component. Relative to the other components in the group.

status

enum

The status of the component. Allowed enum values: operational,degraded,partial_outage,major_outage,maintenance

type

enum

The type of the component. Allowed enum values: component

id

uuid

The ID of the component.

name

string

The name of the component.

position

int64

The zero-indexed position of the component.

status

enum

The status of the component. Allowed enum values: operational,degraded,partial_outage,major_outage,maintenance

type

enum

The type of the component. Allowed enum values: component,group

created_at

date-time

Timestamp of when the status page was created.

custom_domain

string

If configured, the url that the status page is accessible at.

custom_domain_enabled

boolean

Whether the custom domain is configured.

domain_prefix

string

The subdomain of the status page's url taking the form https://{domain_prefix}.statuspage.datadoghq.com. Globally unique across Datadog Status Pages.

email_header_image

string

Base64-encoded image data included in email notifications sent to status page subscribers.

enabled

boolean

Whether the status page is enabled.

favicon

string

Base64-encoded image data displayed in the browser tab.

modified_at

date-time

Timestamp of when the status page was last modified.

name

string

The name of the status page.

page_url

string

The url that the status page is accessible at.

slack_app_icon

string

The Slack app icon URL for the status page.

slack_subscriptions_enabled

boolean

Whether Slack subscriptions are enabled for the status page.

subscriptions_enabled

boolean

Whether users can subscribe to the status page.

type

enum

The type of the status page controlling how the status page is accessed. Allowed enum values: public,internal

visualization_type

enum

The visualization type of the status page. Allowed enum values: bars_and_uptime_percentage,bars_only,component_name_only

id

uuid

The ID of the status page.

relationships

object

The relationships of a status page.

created_by_user

object

The Datadog user who created the status page.

data [required]

object

The data object identifying the Datadog user who created the status page.

id [required]

string

The ID of the Datadog user who created the status page.

type [required]

enum

Users resource type. Allowed enum values: users

default: users

last_modified_by_user

object

The Datadog user who last modified the status page.

data [required]

object

The data object identifying the Datadog user who last modified the status page.

id [required]

string

The ID of the Datadog user who last modified the status page.

type [required]

enum

Users resource type. Allowed enum values: users

default: users

type [required]

enum

Status pages resource type. Allowed enum values: status_pages

default: status_pages

{
  "data": {
    "attributes": {
      "completed_description": "string",
      "component_ids": [],
      "created_at": "2019-09-19T10:00:00.000Z",
      "in_progress_description": "string",
      "maintenance_title": "string",
      "modified_at": "2019-09-19T10:00:00.000Z",
      "name": "string",
      "scheduled_description": "string"
    },
    "id": "string",
    "relationships": {
      "created_by_user": {
        "data": {
          "id": "",
          "type": "users"
        }
      },
      "last_modified_by_user": {
        "data": {
          "id": "",
          "type": "users"
        }
      },
      "status_page": {
        "data": {
          "id": "",
          "type": "status_pages"
        }
      }
    },
    "type": "maintenance_templates"
  },
  "included": [
    {
      "attributes": {
        "email": "string",
        "handle": "string",
        "icon": "string",
        "name": "string",
        "uuid": "string"
      },
      "id": "string",
      "type": "users"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                  ## default
# 

# Path parameters
export page_id="CHANGE_ME"
export template_id="CHANGE_ME"
# Curl command
curl -X PATCH "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/statuspages/${page_id}/maintenance_templates/${template_id}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "completed_description": "We have completed maintenance on the API to improve performance.", "in_progress_description": "We are currently performing maintenance on the API to improve performance for 40 minutes.", "maintenance_title": "API Maintenance", "scheduled_description": "We will be performing maintenance on the API to improve performance for 40 minutes." }, "id": "00000000-0000-0000-0000-000000000004", "type": "maintenance_templates" } } EOF
"""
Update maintenance template returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.status_pages_api import StatusPagesApi
from datadog_api_client.v2.model.patch_maintenance_template_request import PatchMaintenanceTemplateRequest
from datadog_api_client.v2.model.patch_maintenance_template_request_data import PatchMaintenanceTemplateRequestData
from datadog_api_client.v2.model.patch_maintenance_template_request_data_attributes import (
    PatchMaintenanceTemplateRequestDataAttributes,
)
from datadog_api_client.v2.model.patch_maintenance_template_request_data_type import (
    PatchMaintenanceTemplateRequestDataType,
)
from uuid import UUID

body = PatchMaintenanceTemplateRequest(
    data=PatchMaintenanceTemplateRequestData(
        attributes=PatchMaintenanceTemplateRequestDataAttributes(
            component_ids=[],
        ),
        id="",
        type=PatchMaintenanceTemplateRequestDataType.MAINTENANCE_TEMPLATES,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = StatusPagesApi(api_client)
    response = api_instance.update_maintenance_template(
        page_id=UUID("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"),
        template_id=UUID("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"),
        body=body,
    )

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
# Update maintenance template returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::StatusPagesAPI.new

body = DatadogAPIClient::V2::PatchMaintenanceTemplateRequest.new({
  data: DatadogAPIClient::V2::PatchMaintenanceTemplateRequestData.new({
    attributes: DatadogAPIClient::V2::PatchMaintenanceTemplateRequestDataAttributes.new({
      component_ids: [],
    }),
    id: "",
    type: DatadogAPIClient::V2::PatchMaintenanceTemplateRequestDataType::MAINTENANCE_TEMPLATES,
  }),
})
p api_instance.update_maintenance_template("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d", "9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
// Update maintenance template returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	body := datadogV2.PatchMaintenanceTemplateRequest{
		Data: &datadogV2.PatchMaintenanceTemplateRequestData{
			Attributes: &datadogV2.PatchMaintenanceTemplateRequestDataAttributes{
				ComponentIds: []string{},
			},
			Id:   "",
			Type: datadogV2.PATCHMAINTENANCETEMPLATEREQUESTDATATYPE_MAINTENANCE_TEMPLATES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStatusPagesApi(apiClient)
	resp, r, err := api.UpdateMaintenanceTemplate(ctx, uuid.MustParse("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"), uuid.MustParse("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"), body, *datadogV2.NewUpdateMaintenanceTemplateOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StatusPagesApi.UpdateMaintenanceTemplate`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `StatusPagesApi.UpdateMaintenanceTemplate`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
// Update maintenance template returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StatusPagesApi;
import com.datadog.api.client.v2.model.MaintenanceTemplate;
import com.datadog.api.client.v2.model.PatchMaintenanceTemplateRequest;
import com.datadog.api.client.v2.model.PatchMaintenanceTemplateRequestData;
import com.datadog.api.client.v2.model.PatchMaintenanceTemplateRequestDataAttributes;
import com.datadog.api.client.v2.model.PatchMaintenanceTemplateRequestDataType;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    StatusPagesApi apiInstance = new StatusPagesApi(defaultClient);

    PatchMaintenanceTemplateRequest body =
        new PatchMaintenanceTemplateRequest()
            .data(
                new PatchMaintenanceTemplateRequestData()
                    .attributes(new PatchMaintenanceTemplateRequestDataAttributes())
                    .id("")
                    .type(PatchMaintenanceTemplateRequestDataType.MAINTENANCE_TEMPLATES));

    try {
      MaintenanceTemplate result =
          apiInstance.updateMaintenanceTemplate(
              UUID.fromString("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"),
              UUID.fromString("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"),
              body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling StatusPagesApi#updateMaintenanceTemplate");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
// Update maintenance template returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_status_pages::StatusPagesAPI;
use datadog_api_client::datadogV2::api_status_pages::UpdateMaintenanceTemplateOptionalParams;
use datadog_api_client::datadogV2::model::PatchMaintenanceTemplateRequest;
use datadog_api_client::datadogV2::model::PatchMaintenanceTemplateRequestData;
use datadog_api_client::datadogV2::model::PatchMaintenanceTemplateRequestDataAttributes;
use datadog_api_client::datadogV2::model::PatchMaintenanceTemplateRequestDataType;
use uuid::Uuid;

#[tokio::main]
async fn main() {
    let body = PatchMaintenanceTemplateRequest::new().data(
        PatchMaintenanceTemplateRequestData::new(
            "".to_string(),
            PatchMaintenanceTemplateRequestDataType::MAINTENANCE_TEMPLATES,
        )
        .attributes(PatchMaintenanceTemplateRequestDataAttributes::new().component_ids(vec![])),
    );
    let configuration = datadog::Configuration::new();
    let api = StatusPagesAPI::with_config(configuration);
    let resp = api
        .update_maintenance_template(
            Uuid::parse_str("00000000-0000-0000-0000-000000000000").expect("invalid UUID"),
            Uuid::parse_str("00000000-0000-0000-0000-000000000000").expect("invalid UUID"),
            body,
            UpdateMaintenanceTemplateOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
/**
 * Update maintenance template returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.StatusPagesApi(configuration);

const params: v2.StatusPagesApiUpdateMaintenanceTemplateRequest = {
  body: {
    data: {
      attributes: {
        componentIds: [],
      },
      id: "",
      type: "maintenance_templates",
    },
  },
  pageId: "9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d",
  templateId: "9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d",
};

apiInstance
  .updateMaintenanceTemplate(params)
  .then((data: v2.MaintenanceTemplate) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"